#include "common.h"

int matches(char *grp, char *list[], int i)
{
  int r=0;
  char *p;
  while ((p=list[i])) {
    if (*p=='!') {
      ++p;
      if (!strncmp(grp, p, strlen(p)))
	r=0;
    } else {
      if (!strncmp(grp, p, strlen(p)))
	r=1;
    }
    ++i;
  }
  return r;
}

static const char *toremove;

void finish(int e)
{
  if (toremove)
    unlink(toremove);
  unlock();
  putchar('\n');
  if (tot_grp)
    printf("Processed %d groups: added %d, expired %d articles.\n",
	   tot_grp, tot_add, tot_exp);
  exit(e);
}

static void sighandler(int i)
{
  fprintf(stderr, "Got signal %d\n", i);
  finish(4);
}

void setsig(const char *f)
{
  toremove=f;
  signal(SIGHUP, SIG_IGN);
  signal(SIGTERM, sighandler);
  signal(SIGINT, sighandler);
}
